* pour dessiner un label : 
* appeler DrawLabel(thisform.hwnd, thisform.label1)
* la fonction utilise backcolor et disabledbackcolor pour dessiner les couleurs
* la fonction utilise toutes les proprit du label pour la font (fontbold, fontname, forecolor...)

* to draw a label : 
* call DrawLabel(thisform.hwnd, thisform.label1)
* this function uses backcolor and disabledbackcolor to draw the button's colors
* it also uses the properties of label object to draw the text (fontbold, fontname, forecolor...)
*

* we'll need some declare DLL
* the some structures
* DLL : GradientFill, GetDC
* BOOL  GradientFill(HDC, PTRIVERTEX, ULONG, PVOID, ULONG, ULONG);
* HDC GetDC(IN HWND hWnd);
* 
* structures : TRIVERTEX, GRADIENT_RECT, GRADIENT_TRIANGLE
* typedef USHORT COLOR16;
*
*
*typedef struct _TRIVERTEX
*{
*    LONG    x;
*    LONG    y;
*    COLOR16 Red;
*    COLOR16 Green;
*    COLOR16 Blue;
*    COLOR16 Alpha;
*}TRIVERTEX,*PTRIVERTEX,*LPTRIVERTEX;
*
*typedef struct _GRADIENT_TRIANGLE
*{
*    ULONG Vertex1;
*    ULONG Vertex2;
*    ULONG Vertex3;
*}GRADIENT_TRIANGLE,*PGRADIENT_TRIANGLE,*LPGRADIENT_TRIANGLE;
*
*typedef struct _GRADIENT_RECT
*{
*    ULONG UpperLeft;
*    ULONG LowerRight;
*}GRADIENT_RECT,*PGRADIENT_RECT,*LPGRADIENT_RECT;


* defines : GRADIENT_FILL_RECT_V, _H, GRADIENT_FILL_TRIANGLE
#define GRADIENT_FILL_RECT_H    0x00000000
#define GRADIENT_FILL_RECT_V    0x00000001
#define GRADIENT_FILL_TRIANGLE  0x00000002

FUNCTION GetTriVertex(x, y, red, green, blue)
* x, y are LONGS (4 bytes)
* red, green, blue are COLOR16 (2 bytes)
retVal = BINTOC(x, "4SR")	&& x is a long (4 bytes)
retVal = retVal + BINTOC(y, "4SR")
retVal = retVal + BINTOC(red, "2S")
retval = retVal + BINTOC(green, "2S")
retval = retVal + BINTOC(blue, "2S")
* alpha part
retVal = retVal + CHR(0)+CHR(0)
RETURN retVal
ENDFUNC

FUNCTION GetGrTriangle(v1,v2,v3)
retVal = BINTOC(v1, "4SR")
retVal = retVal + BINTOC(v2, "4SR")
retVal = retVal + BINTOC(v3, "4SR")
RETURN retVal
ENDFUNC

FUNCTION GetGrRect(ul,lr)
retVal = BINTOC(ul, "4SR")
retVal = retVal + BINTOC(lr, "4SR")
RETURN retVal
ENDFUNC

FUNCTION DrawLabel(handle, oLabel)
rgbStart = oLabel.BackColor
rgbEnd = oLabel.DisabledBackColor
bs = BITRSHIFT(BITAND(rgbStart, 0x00FF0000), 8+8)
gs = BITRSHIFT(BITAND(rgbStart, 0x0000FF00), 8)
rs = BITAND(rgbStart, 0x000000FF)

be = BITRSHIFT(BITAND(rgbEnd, 0x00FF0000), 8+8)
ge = BITRSHIFT(BITAND(rgbEnd, 0x0000FF00), 8)
re = BITAND(rgbEnd, 0x000000FF)

DrawButton(handle, oLabel, rs, gs, bs, re, ge, be)
ENDFUNC 

#if .F.
FUNCTION DrawBmp(handle, tag, top, left, right, bottom)
	IF ALINES(aExpr, tag, 1+4, ",")=0
		RETURN .F.
	ENDIF
	
	* aExpr[1] -> file
	IF !FILE(aExpr[1])
		RETURN .F.
	ENDIF
	
	DO CASE 
	* aExpr[2] -> position
	CASE EMPTY(aExpr[2])
	CASE aExpr[2]="right"
	OTHERWISE 
	ENDCASE 
	
	* TODO, draw a bitmap
	* get the hBmp from the file and DC
DECLARE integer GetWindowLong IN WIN32API integer hWnd, integer Indice
#define GWL_HINSTANCE       (-6)
hInstance = GetWindowLong(_vfp.hWnd, GWL_HINSTANCE)

*HBITMAP LoadBitmap(
*  HINSTANCE hInstance,  // handle to application instance
*  LPCTSTR lpBitmapName  // name of bitmap resource
*)
	
	* get the rect to draw in
	
ENDFUNC 
#endif

FUNCTION DrawButton(handle, ;
	oLabel, ; && the rect to draw in
	rStart, gStart, bStart, ; && the first color (R, G, B)
	rEnd, gEnd, bEnd)  && the second color (R, G, B)

left =  oLabel.Left
top = 	oLabel.Top
right =	oLabel.Left+oLabel.Width
bottom = oLabel.Top+oLabel.Height

x = (left+right)/2
y = (top+bottom)/2
DrawShadedRect(handle, left, top, right, y, rStart, gStart, bStart, rEnd, gEnd, bEnd, 1)
DrawShadedRect(handle, left, y, right, bottom, rEnd, gEnd, bEnd, rStart, gStart, bStart, 1)

DrawText(handle, left, top, right, bottom, oLabel)

#if .F.
* TODO
IF !EMPTY(oLabel.tag)
	DrawBmp(handle, oLabel.tag, top, left, right, bottom)
ENDIF
#endif
ENDFUNC

FUNCTION GetRect(left, top, right, bottom)
retVal = BINTOC(left, "4SR")
retVal = retVal + BINTOC(top, "4SR")
retVal = retVal + BINTOC(right, "4SR")
retVal = retVal + BINTOC(bottom, "4SR")
RETURN retVal
ENDFUNC

#define DT_TOP                      0x00000000
#define DT_LEFT                     0x00000000
#define DT_CENTER                   0x00000001
#define DT_RIGHT                    0x00000002
#define DT_VCENTER                  0x00000004
#define DT_SINGLELINE               0x00000020
#define DT_END_ELLIPSIS             0x00008000
#define TRANSPARENT         1
#define OPAQUE              2

#define FW_DONTCARE         0
#define FW_THIN             100
#define FW_EXTRALIGHT       200
#define FW_LIGHT            300
#define FW_NORMAL           400
#define FW_MEDIUM           500
#define FW_SEMIBOLD         600
#define FW_BOLD             700
#define FW_EXTRABOLD        800
#define FW_HEAVY            900

*#define LF_FACESIZE         32
*typedef struct tagLOGFONTA
*{
*    LONG      lfHeight;
*    LONG      lfWidth;
*    LONG      lfEscapement;
*    LONG      lfOrientation;
*    LONG      lfWeight;
*    BYTE      lfItalic;
*    BYTE      lfUnderline;
*    BYTE      lfStrikeOut;
*    BYTE      lfCharSet;
*    BYTE      lfOutPrecision;
*    BYTE      lfClipPrecision;
*    BYTE      lfQuality;
*    BYTE      lfPitchAndFamily;
*    CHAR      lfFaceName[LF_FACESIZE];
*} LOGFONTA, *PLOGFONTA, NEAR *NPLOGFONTA, FAR *LPLOGFONTA;

FUNCTION GetLogFont(oLabel)
fS = - oLabel.FontSize * 96 / 72 && 96 = GetDeviceCaps(hdc, LOGPIXELSY) standard. Peut tre toutes fois paramtr
retVal = BINTOC(fS, "4RS") && Height
retVal = retVal + BINTOC(0, "4RS") && Width
retVal = retVal + BINTOC(0, "4RS") && escapment
retVal = retVal + BINTOC(0, "4RS") && orientation

* weight
IF oLabel.FontBold
		retval = retval + BINTOC(FW_BOLD, "4RS")
ELSE
	IF oLabel.FontCondense
		retval = retval + BINTOC(FW_THIN, "4RS")
	ELSE
		IF oLabel.FontExtend
			retVal = retVal + BINTOC(FW_SEMIBOLD, "4RS")
		ELSE
			retVal = retVal + BINTOC(0, "4RS")
		ENDIF
	ENDIF
ENDIF 

retVal = retVal + BINTOC(IIF(oLabel.FontItalic, 1, 0), "1S")
retVal = retVal + BINTOC(IIF(oLabel.FontUnderLine, 1, 0), "1S")
retVal = retVal + BINTOC(IIF(oLabel.FontStrikeThru, 1, 0), "1S")
retVal = retVal + BINTOC(oLabel.FontCharset, "1S")
retVal = retVal + BINTOC(0, "1S") && OutPrecision
retVal = retVal + BINTOC(0, "1S") && ClipPrecision
retVal = retVal + BINTOC(0, "1S") && Quality
retVal = retVal + BINTOC(0, "1S") && PitchAndFamilly
retVal = retVal + PADR(oLabel.FontName, 32, CHR(0)) && OutPrecision
RETURN retVal
ENDFUNC


FUNCTION SetFont(oLabel)

hFont = 0

lf = GetLogFont(oLabel)	

* HFONT   CreateFontIndirectA( IN CONST LOGFONTA *)
DECLARE integer CreateFontIndirectA  IN WIN32API as CreateFontIndirect string@ logFont

hFont = CreateFontIndirect(@lf)

RETURN hfont	
ENDFUNC

FUNCTION DrawText(handle,;
				 left, top, right, bottom,;
				 oLabel)
DECLARE integer GetDC IN WIN32API integer wndHandle
DECLARE integer ReleaseDC IN WIN32API integer handle, integer hdc

hdc = GetDC(handle)
IF hdc==0
	RETURN .F.
ENDIF 
caption = oLabel.caption

hFont = SetFont(oLabel)

* HGDIOBJ SelectObject(IN HDC, IN HGDIOBJ)
* WINGDIAPI BOOL WINAPI DeleteObject( IN HGDIOBJ)

DECLARE integer SelectObject IN WIN32API integer hdc, integer hGDIobj
DECLARE integer DeleteObject IN WIN32API integer hGDIobj

DECLARE integer SetTextColor IN WIN32API integer hdc, integer colorref

OldColor = SetTextColor(hdc, oLabel.ForeColor)

hOldFont=SelectObject(hdc, hFont)

*int
*DrawTextExW(
*    IN HDC,
*    IN OUT LPSTR,
*    IN int,
*    IN OUT LPRECT,
*    IN UINT,
*    IN LPDRAWTEXTPARAMS)
* draw the text of the label using DrawTextEx
*int   WINAPI SetBkMode(IN HDC, IN int)
DECLARE integer DrawTextEx IN WIN32API integer hdc, string@ caption, integer, string@ rect, integer dt, string@ extparams
DECLARE integer SetBkMode IN WIN32API integer hdc, integer mode

*DrawTextEx(hdc, bar->pszText, -1 ,&rc, , NULL)
texte = caption

rect = GetRect(left, top, right, bottom)

SetBkMode( hdc, TRANSPARENT);

DrawTextEx(hdc, @texte, -1, @rect, DT_CENTER + DT_VCENTER + DT_SINGLELINE + DT_END_ELLIPSIS, 0)

SetTextColor(hdc, OldColor)

DeleteObject(hFont)
SelectObject(hdc, hOldFont)

ReleaseDC(handle, hdc)
ENDFUNC

FUNCTION DrawShadedRect(handle, ;
	left, top, right, bottom, ; && the rect to draw in
	rStart, gStart, bStart, ; && the first color (R, G, B)
	rEnd, gEnd, bEnd,;  && the second color (R, G, B)
	pStyle) && the style of the gradient 0->hor, 1->vert, 2->porcelaine, 3->flamme
*BOOL  GradientFill(HDC, PTRIVERTEX, ULONG, PVOID, ULONG, ULONG)
DECLARE integer GradientFill IN msimg32.dll integer hdc, string@ pVert, integer nbTri, string@ pGr, integer nbGr, integer lStyle
DECLARE integer GetDC IN WIN32API integer wndHandle
DECLARE integer ReleaseDC IN WIN32API integer handle, integer hdc

hdc = GetDC(handle)
IF hdc==0
	RETURN .F.
ENDIF 

* internal structs
LOCAL vert, vert0, vert1, vert2, vert3, vert4, vert5 as String && array of 6 trivertex
LOCAL grRect as String && gradient_rect
LOCAL grTriangle, grTriangle0, grTriangle1 as String && array of 2 gradient_triangle

LOCAL lStyle as Long

IF pStyle=1
	lStyle = GRADIENT_FILL_RECT_V
ELSE
	IF pStyle=0
		lStyle = GRADIENT_FILL_RECT_H  
	ELSE
		lStyle = GRADIENT_FILL_TRIANGLE
	ENDIF
ENDIF

* the trivertex are structures
* having a point and a color
vert0 = GetTriVertex(left, top, rStart, gStart, bStart) && first trivertex
vert1 = GetTriVertex(right, bottom, rEnd, gEnd, bEnd) && second trivertex
* others trivertex depending on the style
IF lStyle=GRADIENT_FILL_TRIANGLE

	vert2 = GetTriVertex(right, top, 255,255,255)

	IF pStyle=2
		vert3 = vert0
		vert4 = vert1
		vert5 = GetTriVertex(left, bottom, 255,255,255)
	ELSE
		vert3=vert0
		vert4=vert1
		vert5= GetTriVertex(left, bottom, rStart, gStart, bStart)
	ENDIF

	grTriangle0 = GetGrTriangle(3,4,5)
	grTriangle1 = GetGrTriangle(0,1,2)

	vert=vert0+vert1+vert2+vert3+vert4+vert5
	grTriangle = grTriangle0+grTriangle1
	
	GradientFill(hdc, @vert, 6,	@grTriangle,	2,	lStyle)
	
ELSE
	grRect = GetGrRect(0,1)
	vert = vert0+vert1
	GradientFill(hdc, @vert, 2, @grRect, 1, lStyle)
ENDIF

ReleaseDC(handle, hdc)
	
ENDFUNC

